#!/usr/bin/python
# -*- coding: utf-8 -*-
#

#Copyright (C) 2006-2007  Néstor Arocha Rodríguez, Inmaculada Luengo Merino

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""Todas las clases base que no poseen fichero propio"""


class ListaFicheros(list):
    """
    Contenedor de la lista de ficheros. 
    Funciona como cola LIFO, y hereda de list.
    El parametro pasado es la longitud de lista que se desea
    """
    def __init__(self, size, lista=None):
        """
        El parametro size es la longitud de lista que se desea
        """
        self.__nelementos = size
        if isinstance(lista, list):
            list.__init__(self, lista)
        else:
            list.__init__(self)

    def insert(self, elemento):
        """Inserta un elemento"""
        if elemento in self:
            self.remove(elemento)
        list.insert(self, 0, elemento)
        if len(self) > self.__nelementos:
            self.pop()

