#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006-2007  Néstor Arocha Rodríguez, Inmaculada Luengo Merino 

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA



from Driza.iuqt3.ui.dfiltrado import DialogoFiltro
from qt import *
import logging
log = logging.getLogger("Driza.iu.dialogs.dfiltrado")


class DFiltrado(DialogoFiltro):
    """Dialogo que permite establecer el filtro"""
    
    def __init__(self,parent,interfazdatosusuario):
        DialogoFiltro.__init__(self,parent)
        self.__conexiones()
        self.__idu=interfazdatosusuario

    def __conexiones(self):
        """Función que define las conexiones entre elementos de la interfaz y sus SLOTS"""
        self.connect(self.pushButton1,SIGNAL("clicked()"),self.accept)
        self.connect(self.pushButton2,SIGNAL("clicked()"),self.reject)
        self.connect(self.pushButton3,SIGNAL("clicked()"),self.__insertarSimboloGT)
        self.connect(self.pushButton4,SIGNAL("clicked()"),self.__insertarSimboloLT)
        self.connect(self.pushButton5,SIGNAL("clicked()"),self.__insertarSimboloEQ)
        self.connect(self.pushButton6,SIGNAL("clicked()"),self.__insertarSimboloNE)
        self.connect(self.pushButton7,SIGNAL("clicked()"),self.__insertarSimboloAND)
        self.connect(self.pushButton8,SIGNAL("clicked()"),self.__insertarSimboloOR)
        self.connect(self.pushButton9,SIGNAL("clicked()"),self.__desactivarfiltro)
        self.connect(self.pushButton10,SIGNAL("clicked()"),self.__insertarSimboloXOR)
        self.connect(self.pushButton11,SIGNAL("clicked()"),self.__insertarSimboloLE)
        self.connect(self.pushButton12,SIGNAL("clicked()"),self.__insertarSimboloGE)
        self.connect(self.comboBox1,SIGNAL("activated (int)"),self.__insertarvariable)

    def showEvent(self,ev):
        self.myUpdate()
        DialogoFiltro.showEvent(self,ev)

    def accept(self):
        expresion=self.textEdit1.text().latin1()
        if not expresion:
            self.__desactivarfiltro()
        else:
            try:
                self.__idu.setFiltro(expresion)
            except:
                log.exception("Capturada excepcion en el manejo del filtro")
            else:
                self.parent().grid.myUpdate()
                DialogoFiltro.accept(self)

    def __insertarSimboloGT(self): self.textEdit1.insert(">")
    def __insertarSimboloLT(self): self.textEdit1.insert("<")
    def __insertarSimboloEQ(self): self.textEdit1.insert("==")
    def __insertarSimboloNE(self): self.textEdit1.insert("!=")
    def __insertarSimboloAND(self): self.textEdit1.insert(" and ")
    def __insertarSimboloOR(self): self.textEdit1.insert(" or ")
    def __insertarSimboloXOR(self): self.textEdit1.insert("^")
    def __insertarSimboloGE(self): self.textEdit1.insert(">=")
    def __insertarSimboloLE(self): self.textEdit1.insert("<=")

    def __insertarvariable(self,indice=0):
        self.textEdit1.insert(self.comboBox1.currentText())

    def __desactivarfiltro(self):
        self.__idu.delFiltro()
        self.parent().grid.myUpdate()
        DialogoFiltro.accept(self)

    def __actualizarcombovars(self):
        """Actualiza la caja de variables disponibles"""
        self.comboBox1.clear()
        for var in self.__idu.arrTit():
            self.comboBox1.insertItem(var)

    def myUpdate(self):
        self.__actualizarcombovars()


