#!/usr/bin/python
# -*- coding: utf-8 -*-
###################################
#
#  DRIZA
#
###################################


#Copyright (C) 2006-2007  Néstor Arocha Rodríguez, Inmaculada Luengo Merino 
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""Interfaces a las clases de interfaz de usuario"""

import temas
from qt import *
import logging
from vprincipal.vprincipal import VPrincipal
from dcrevar import DCrevar
from dsplash import DSplash
from vsalida import VSalida
from dimportartexto import DImportarTexto
from Driza import gestores
from operaciones.doperaciones import DOperaciones
log = logging.getLogger("Driza.iuqt3.interfaz")

class InterfazQt3(QApplication):
    def __init__(self,interfazconfig,portero,idu,idf,interfazproyectos,interfazoperaciones,gestorpaquetes,options,esnuevo,version):
        QApplication.__init__(self,[])
        self.__options=options
        self.__nuevo=esnuevo
        self.__version=version
        gestortemas=temas.GestorTemas()
        gestorsalida = gestores.GestorSalida()
        log.info('Cargado modulo de temas')
        self.__iconfig=interfazconfig
        self.__idu=idu
        self.__iproyectos=interfazproyectos
        self.__ioperaciones=interfazoperaciones
        self.__itemas=gestortemas
        self.vprincipal = VPrincipal(self,self.__iconfig,portero,self.__idu,self.__iproyectos,gestortemas)
        self.vsalida = VSalida(self,gestorsalida,gestortemas)
        self.dcrevar = DCrevar(self.vprincipal,self.__idu,interfazconfig,gestorpaquetes)
        log.info('Cargado dialogo de creación de variables')
        self.__dsplash = DSplash(self.vprincipal,gestortemas,self.__iproyectos,self.__iconfig,self.vsalida)
        self.doperaciones = DOperaciones(self.vprincipal,self.__idu,interfazoperaciones,self.vsalida)
        self.dimportartexto=DImportarTexto(self.vprincipal,idf)
        #Realizando conexiones
        self.vprincipal.conexiones()

    def loop(self):
        """ 
        Procedimiento Bucle principal. 
        Lanza la ventana splash despues de la principal para que obtenga el foco
        Despues espera nuevos eventos por parte del usuario
        """
        self.vprincipal.show()
        if self.__options.vsplash==None: 
            if (self.__iconfig.configuracion["vsplash"] and not self.__iproyectos.fichero):
                self.__dsplash.show()
        elif self.__options.vsplash:
            self.__dsplash.show()
        if self.__nuevo:
            #Es la primera vez que se ejecuta el programa
            rc = QMessageBox.information(self.vprincipal,'Bienvenido', 'Parece que es la primera vez que ejecutas Driza')
        logging.info('Lanzando Bucle Principal')
        self.exec_loop() 
        return

    def version(self):
        return self.__version
