#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (C) 2006-2007  Nstor Arocha Rodrguez,Inmaculada Luengo Merino 

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by

#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


"""Clases base de la salida"""

class FormatoResultado(dict):
    """Almacena las diferentes definiciones de resultado"""
    def __init__(self, nombre, config):
        self.__nombre = nombre
        self.__config = config
        dict.__init__(self)
        self.__listaordenada = [] #guarda los elementos ordenados
        #TODO FALTA  un nombre para genrar titulo a la salida

    def __setitem__(self, indice, elemento):
        """Equivalente al append de list, salvo que controla los tipos"""
        from componenteresultado import DefinicionElementoResultado
        assert(isinstance(elemento, DefinicionElementoResultado))
        dict.__setitem__(self, indice, elemento)
        self.__listaordenada.append(indice)

    def renderizar(self, listaresultados):
        """Devuelve un ResultadoOperacion con todos sus elementos ya relleno"""
        resultadooperacion = ResultadoOperacion()
        from componentesalida import CSTexto
        titulo = CSTexto(size = 5)
        titulo.set(self.__nombre)
        separador = CSTexto()
        separador.set("<br>")
        resultadooperacion.append(titulo)
        for indice in self.__listaordenada:
            objetodefinicion = self.__getitem__(indice)
            listafiltrada = []
            for diccionario in listaresultados:
                #Solo enviamos los diccionarios destinados a ese elemento de salida
                listafiltrada.append(diccionario[indice]) 
            resultadooperacion.append(objetodefinicion.renderizar(listafiltrada))
            resultadooperacion.append(separador)
        return resultadooperacion


class ResultadoOperacion(list):
    """Esta clase representa un resultado, 
    que es un conjunto de DefinicionElementosresultado. 
    Posee funciones para conversion a html
    """
    def __init__(self):
        self.titulo = ""
        list.__init__(self)


    def html(self):
        """Genera el html a partir de todos sus componentes + el titulo"""
        ristra = u""
        ristra += "<h1>"+self.titulo+"</h1>"
        for elemento in self:
            ristra += elemento.html()
        return ristra
        
    def exportarhtml(self, ruta):
        """Genera el html a partir de todos sus componentes + el titulo"""
        ristra = u""
        ristra += "<h1>"+self.titulo+"</h1>"
        for elemento in self:
            ristra += elemento.exportarhtml(ruta)
        return ristra

